> ## Documentation Index
> Fetch the complete documentation index at: https://docs.gmicloud.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Create an API key

> Allows a user to generate an API key for their organization.



## OpenAPI

````yaml /api-spec/ias-public-api.yaml post /organizations/{orgId}/api-keys
openapi: 3.0.3
info:
  title: IAM Service API
  description: APIs for IAM Service.
  version: 2.4.0
servers:
  - url: https://console.gmicloud.ai/api/v1
    description: IAM Service API
security: []
paths:
  /organizations/{orgId}/api-keys:
    post:
      tags:
        - organizations
      summary: Create an API key
      description: Allows a user to generate an API key for their organization.
      operationId: createApiKey
      parameters:
        - $ref: '#/components/parameters/orgIdParam'
      requestBody:
        description: The API key creation request.
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/createApiKeyRequest'
      responses:
        '201':
          description: Successfully created an API key.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/createApiKeyResponse'
        '400':
          description: >
            - [group:**request**, code:**0**]: Invalid field in the request.

            - [group:**request**, code:**1**]: The request body is required.

            - [group:**api-key**, code:**0**]: The organization has reached the
            maximum number of API keys.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrStatusMsg'
              examples:
                Invalid field in the request:
                  summary: Invalid field in the request.
                  value:
                    group: request
                    code: 0
                    validationDetail:
                      - field: name
                        expression: required
                        originalValue: ''
                        reason: This field is required.
                No request body:
                  summary: No request body.
                  value:
                    group: request
                    code: 1
                    message: The request body is required.
        '404':
          description: |
            - [group:**organization**, code:**2**]: Organization does not exist.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrStatusMsg'
              examples:
                Organization does not exist:
                  summary: Organization does not exist.
                  value:
                    group: organization
                    code: 2
                    message: Organization does not exist.
        '500':
          description: >
            - [group:**api-key**, code:**1000**]: Create API key encountered DB
            error.

            - [group:**api-key**, code:**1200**]: Get API key list encountered
            DB error.

            - [group:**organization**, code:**1201**]: Get organization
            encountered DB error.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrStatusMsg'
              examples:
                Create api-key encountered DB error:
                  summary: Create api-key encountered DB error.
                  value:
                    group: api-key
                    code: 1000
                    message: Create api-key encountered DB error.
                    traces:
                      - DB error occurred.
      security:
        - bearerAuth: []
components:
  parameters:
    orgIdParam:
      name: orgId
      in: path
      schema:
        type: string
        format: uuid
        x-go-type: uuid.UUID
        example: a0eebc99-9c0b-4ef8-bb6d-6bb9bd380a11
      required: true
      description: |
        The organization's ID.
        - Must be a valid UUID.
  schemas:
    createApiKeyRequest:
      type: object
      x-go-name: createApiKeyRequest
      properties:
        name:
          type: string
          description: The API key name.
          example: My Service API Key
          x-oapi-codegen-extra-tags:
            binding: required
        scope:
          type: string
          description: The API key scope. Default value is `ie_model`.
          enum:
            - ie_model
            - ce_resource
          x-go-type: ceCommonLibTypes.IasAPIKeyScope
          x-go-type-import:
            path: >-
              us-central1-go.pkg.dev/gmi-cloud-cicd/go-dev/ce-common-lib-go/pkg/types
            name: ceCommonLibTypes
          example: ie_model
          x-go-type-skip-optional-pointer: true
          x-oapi-codegen-extra-tags:
            binding: omitempty,oneof=ie_model ce_resource
            default: ie_model
        expiresAt:
          type: integer
          x-go-type: int64
          description: >
            The UNIX timestamp when API key will expire (UTC).

            - Must be a UNIX timestamp in seconds and must be greater than the
            current time.

            - If not set, the key will not expire.
          example: 1738812775
          x-oapi-codegen-extra-tags:
            binding: omitempty,expirationTime
      required:
        - name
    createApiKeyResponse:
      type: object
      x-go-name: createApiKeyResponse
      properties:
        key:
          type: string
          description: The generated API key (returned only once).
          example: eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpZCI6ImM2NDNh...
      required:
        - key
    ErrStatusMsg:
      type: object
      properties:
        group:
          type: string
          description: >-
            API function group\n -Will be "request" if there are invalid request
            parameters.
          x-oapi-codegen-extra-tags:
            binding: required
        code:
          type: integer
          description: The substatus error code for the API response.
          x-oapi-codegen-extra-tags:
            binding: required
        message:
          type: string
          description: The substatus error Message for API response.
          x-go-type-skip-optional-pointer: true
        traces:
          type: array
          items:
            type: string
          description: The original error messages.
          x-go-type-skip-optional-pointer: true
        validationDetail:
          type: array
          items:
            $ref: '#/components/schemas/ValidationDetail'
          description: >-
            Returned when there are invalid request
            paremeters(group="request")\n List of invalid fields and the reason
            of error.
          x-go-type-skip-optional-pointer: true
      example:
        group: request
        code: 0
        validationDetail:
          - field: email
            expression: required
            originalValue: ''
            reason: This field is required.
      required:
        - group
        - code
    ValidationDetail:
      type: object
      properties:
        field:
          type: string
          description: The field of the request data.
          x-go-type-skip-optional-pointer: true
        expression:
          type: string
          description: The form of violation.
          x-go-type-skip-optional-pointer: true
        argument:
          type: string
          description: The number or data to support the expression.
          x-go-type-skip-optional-pointer: true
        originalValue:
          description: The original value from the request.
          x-go-type-skip-optional-pointer: true
        reason:
          type: string
          description: The reason for the validation error.
          x-go-type-skip-optional-pointer: true
      example:
        - field: fieldXXX
          expression: required
          originalValue: ''
          reason: This field is required.
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: >
        An access token used to authenticate a user and grant access to
        restricted APIs. It is issued by session APIs.

        For status codes related to this header, refer to the 

        [Common Headers
        Documentation](https://gmicloud.atlassian.net/wiki/spaces/CE/pages/47199534/Common+Headers#Authorization).

````